Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto.digests
Class TupleHash

    java.lang.Object
      org.bouncycastle.crypto.digests.TupleHash

All Implemented Interfaces:
  Digest, EncodableDigest, EncodableService, ExtendedDigest, Memoable, SavableDigest, Xof

public class TupleHash
extends java.lang.Object
implements Xof, SavableDigest

TupleHash - a hash designed to simply hash a tuple of input strings, any or all of which may be empty strings, in an unambiguous way with an optional XOF mode.

From NIST Special Publication 800-185 - SHA-3 Derived Functions:cSHAKE, KMAC, TupleHash and ParallelHash

Constructor Summary
`TupleHash(byte[] state)`
`TupleHash(int bitLength, byte[] S)` Base constructor.
`TupleHash(int bitLength, byte[] S, int outputSize)`
`TupleHash(TupleHash original)`

Method Summary
`Memoable` | `copy()` Produce a copy of this object with its configuration and in its current state.
`int` | `doFinal(byte[] out, int outOff)` close the digest, producing the final digest value.
`int` | `doFinal(byte[] out, int outOff, int outLen)` Output the results of the final calculation for this digest to outLen number of bytes.
`int` | `doOutput(byte[] out, int outOff, int outLen)` Start outputting the results of the final calculation for this digest.
`java.lang.String` | `getAlgorithmName()` return the algorithm name
`int` | `getByteLength()` Return the size in bytes of the internal buffer the digest applies it's compression function to.
`int` | `getDigestSize()` return the size, in bytes, of the digest produced by this message digest.
`byte[]` | `getEncodedState()` Return an encoded byte array for the digest's internal state
`void` | `reset()` reset the digest back to it's initial state.
`void` | `reset(Memoable other)` Restore a copied object state into this object.
`void` | `update(byte in)` update the message digest with a single byte.
`void` | `update(byte[] in, int inOff, int len)` update the message digest with a block of bytes.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TupleHash

    public TupleHash(int bitLength,
                     byte[] S)

  Base constructor.

Parameters:
  `bitLength` - bit length of the underlying SHAKE function, 128 or 256.
  `S` - the customization string - available for local use.

### TupleHash

    public TupleHash(int bitLength,
                     byte[] S,
                     int outputSize)

### TupleHash

    public TupleHash(TupleHash original)

### TupleHash

    public TupleHash(byte[] state)

Method Detail

### getAlgorithmName

    public java.lang.String getAlgorithmName()

  Description copied from interface: `Digest`
  return the algorithm name

  Specified by:
    `getAlgorithmName` in interface `Digest`
  Returns:
    the algorithm name

### getByteLength

    public int getByteLength()

  Description copied from interface: `ExtendedDigest`
  Return the size in bytes of the internal buffer the digest applies it's compression function to.

  Specified by:
    `getByteLength` in interface `ExtendedDigest`
  Returns:
    byte length of the digests internal buffer.

### getDigestSize

    public int getDigestSize()

  Description copied from interface: `Digest`
  return the size, in bytes, of the digest produced by this message digest.

  Specified by:
    `getDigestSize` in interface `Digest`
  Returns:
    the size, in bytes, of the digest produced by this message digest.

### update

    public void update(byte in)
                throws java.lang.IllegalStateException

  Description copied from interface: `Digest`
  update the message digest with a single byte.

  Specified by:
    `update` in interface `Digest`
  Parameters:
    `in` - the input byte to be entered.
  Throws:
    `java.lang.IllegalStateException`

### update

    public void update(byte[] in,
                       int inOff,
                       int len)
                throws DataLengthException,
                       java.lang.IllegalStateException

  Description copied from interface: `Digest`
  update the message digest with a block of bytes.

  Specified by:
    `update` in interface `Digest`
  Parameters:
    `in` - the byte array containing the data.
    `inOff` - the offset into the byte array where the data starts.
    `len` - the length of the data.
  Throws:
    `DataLengthException`
    `java.lang.IllegalStateException`

### doFinal

    public int doFinal(byte[] out,
                       int outOff)
                throws DataLengthException,
                       java.lang.IllegalStateException

  Description copied from interface: `Digest`
  close the digest, producing the final digest value. The doFinal call leaves the digest reset.

  Specified by:
    `doFinal` in interface `Digest`
  Parameters:
    `out` - the array the digest is to be copied into.
    `outOff` - the offset into the out array the digest is to start at.
  Throws:
    `DataLengthException`
    `java.lang.IllegalStateException`

### doFinal

    public int doFinal(byte[] out,
                       int outOff,
                       int outLen)

  Description copied from interface: `Xof`
  Output the results of the final calculation for this digest to outLen number of bytes.

  Specified by:
    `doFinal` in interface `Xof`
  Parameters:
    `out` - output array to write the output bytes to.
    `outOff` - offset to start writing the bytes at.
    `outLen` - the number of output bytes requested.
  Returns:
    the number of bytes written

### doOutput

    public int doOutput(byte[] out,
                        int outOff,
                        int outLen)

  Description copied from interface: `Xof`
  Start outputting the results of the final calculation for this digest. Unlike doFinal, this method will continue producing output until the Xof is explicitly reset, or signals otherwise.

  Specified by:
    `doOutput` in interface `Xof`
  Parameters:
    `out` - output array to write the output bytes to.
    `outOff` - offset to start writing the bytes at.
    `outLen` - the number of output bytes requested.
  Returns:
    the number of bytes written

### reset

    public void reset()

  Description copied from interface: `Digest`
  reset the digest back to it's initial state.

  Specified by:
    `reset` in interface `Digest`

### getEncodedState

    public byte[] getEncodedState()

  Description copied from interface: `EncodableDigest`
  Return an encoded byte array for the digest's internal state

  Specified by:
    `getEncodedState` in interface `EncodableDigest`
  Returns:
    an encoding of the digests internal state.

### copy

    public Memoable copy()

  Description copied from interface: `Memoable`
  Produce a copy of this object with its configuration and in its current state.

  The returned object may be used simply to store the state, or may be used as a similar object starting from the copied state.

  Specified by:
    `copy` in interface `Memoable`

### reset

    public void reset(Memoable other)

  Description copied from interface: `Memoable`
  Restore a copied object state into this object.

  Implementations of this method should try to avoid or minimise memory allocation to perform the reset.

  Specified by:
    `reset` in interface `Memoable`
  Parameters:
    `other` - an object originally `copied` from an object of the same type as this instance.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD